﻿Imports be.ehealth.business.kmehrcommons

Imports be.business.connector.recipe.executor
Imports be.business.connector.mycarenet
Imports be.business.connector.mycarenet.mock
Imports be.business.connector.gfddpp.tipsystem.mock
Imports be.business.connector.gfddpp.tipsystem
Imports be.business.connector.gfddpp.pcdh.mock
Imports be.business.connector.gfddpp.pcdh
Imports be.business.connector.common
Imports be.business.connector.core.utils
Imports be.business.connector.gfddpp.domain
Imports be.business.connector.gfddpp.domain.medicationscheme.protocol
Imports be.business.connector.recipe.executor.domain

Imports be.ehealth.businessconnector.chapterIV.builders
Imports be.ehealth.businessconnector.chapterIV.domain
Imports be.ehealth.businessconnector.chapterIV.session
Imports be.ehealth.businessconnector.chapterIV.utils
Imports be.apb.gfddpp.common.utils
Imports java.io
Imports be.fgov.ehealth.standards.kmehr.schema.v1
Imports be.fgov.ehealth.chap4.protocol.v1
Imports be.business.connector.session
Imports System.Text
Imports be.ehealth.technicalconnector.config
Imports be.fgov.ehealth.technicalconnector.bootstrap.bcp.parser
Imports be.ehealth.technicalconnector.utils

Public Class ExecutorTool

    Dim moduleRecipeInstance
    Dim modulePCDHInstance
    Dim moduleTIPSystemInstance
    Dim moduleMyCareNetInstance
    Dim moduleRequestorInstance
    Dim initPCDH = False
    Dim initTIPSystem = False
    Dim initRecipeModule = False
    Dim systemInitialized = False
    Dim listOpenPrescriptionsListPageNumber As Integer = 0
    Dim ListRidsHistoryPageNumber As Integer = 0
    Dim listMandatesPageNumber As Integer = 0
    Dim listRidsInProcessPageNumber As Integer = 0
    Dim GetOpenPrescriptionsResult As be.recipe.services.executor.ListOpenPrescriptionsResult
    Dim ListReservationsResult As be.recipe.services.executor.ListReservationsResult

    Function GetRecipeModule(ByVal enableExecutorV3 As Boolean) As ExecutorIntegrationModuleV4
        InitSystem()
        Dim bcpUrl As String = PropertyHandler.getInstance().getProperties().getProperty("be.ehealth.technicalconnector.bcp.status.endpoint")
        java.lang.System.setProperty("javax.net.ssl.trustStore", "C:/projects/development/recipe-business-connector_1.8.0/dist/executor/conf/p12/acc/truststore.jks")
        java.lang.System.setProperty("javax.net.ssl.trustStorePassword", "changeit")
        GetRecipeModule = New ExecutorIntegrationModuleV4Impl()
    End Function

    Function GetMyCareNetModule(ByVal enableVersion2 As Boolean) As MyCareNetIntegrationModule
        InitSystem()
        If InStr(Command$, "-mock=true") Then
            moduleMyCareNetInstance = New MyCareNetIntegrationModuleMock
        Else
            If enableVersion2 Then
                moduleMyCareNetInstance = New MyCareNetIntegrationModuleV2Impl()
            Else
                moduleMyCareNetInstance = New MyCareNetIntegrationModuleImpl()
            End If
        End If
        GetMyCareNetModule = moduleMyCareNetInstance
    End Function
    Function GetTIPSystemModule() As TIPSystemIntegrationModule
        InitSystem()
        If initTIPSystem = False Then
            If InStr(Command$, "-mock=true") Then
                moduleTIPSystemInstance = New TIPSystemIntegrationModuleMock
            Else
                moduleTIPSystemInstance = New TIPSystemIntegrationModuleImpl
            End If
            initTIPSystem = True
        End If
        GetTIPSystemModule = moduleTIPSystemInstance
    End Function
    Function GetPCDHModule() As PCDHIntegrationModule
        InitSystem()
        If initPCDH = False Then
            If InStr(Command$, "-mock=true") Then
                modulePCDHInstance = New PCDHIntegrationModuleMock
            Else
                modulePCDHInstance = New PCDHIntegrationModuleImpl()
            End If
            initPCDH = True
        End If
        GetPCDHModule = modulePCDHInstance
    End Function

    Function createNewSession(ByVal sessionType As SessionType, ByVal inss As String, ByVal password As String) As String
        Dim sessionItem As be.ehealth.technicalconnector.session.SessionItem
        Dim resultSession As String
        InitSystem()
        If InStr(Command$, "-mock=true") Then
            resultSession = "Create session not supported for mock"
        Else
            sessionItem = be.business.connector.session.SessionUtil.createSession(sessionType, PropertyHandler.getInstance().getPropertiesCopy, inss, password)
            resultSession = SAML10Converter.toXMLString(sessionItem.getSAMLToken.getAssertion)
        End If
        createNewSession = resultSession
    End Function


    Private Sub InitSystem()

        If systemInitialized = False Then
            Me.ListOpenPrescriptionsPageNumberLabel.Text = "Page: " & listOpenPrescriptionsListPageNumber
            Me.ListRidsHistoryMonthLabel.Text = "Page: " & ListRidsHistoryPageNumber
            Me.ListMandatesPageNumberLabel.Text = "Page: " & listMandatesPageNumber
            Me.ListRidsInProcessPageNumberLabel.Text = "Page: " & listRidsInProcessPageNumber
            If InStr(Command$, "-mock=true") Then
                ApplicationConfig.getInstance().initialize()
                systemInitialized = True
            Else
                Dim config As String = Nothing
                Dim configValidation As String = Nothing
                Dim foundConfig As Boolean = False
                Dim foundValidationConfig As Boolean = False
                For Each argument In Command$().Split(" ")
                    If InStr(argument, "-config=") Then
                        foundConfig = True
                        config = argument.ToString.Substring(8)
                        Debug.Print("Config file used  " & config)
                    End If
                    If InStr(argument, "-configValidation=") Then
                        foundValidationConfig = True
                        configValidation = argument.ToString.Substring(18)
                        Debug.Print("Config file used  " & configValidation)
                    End If
                    If foundConfig And foundValidationConfig Then
                        Exit For
                    End If
                Next
                If Not String.IsNullOrEmpty(config) And Not String.IsNullOrEmpty(configValidation) Then
                    ApplicationConfig.getInstance().initialize(config, configValidation)
                    systemInitialized = True
                    Exit Sub
                End If
            End If
        End If
    End Sub



    Private Sub showError(ByVal p1 As ErrObject)
        If TypeOf p1.GetException Is be.business.connector.core.exceptions.IntegrationModuleValidationException Then
            Dim validationErrorsString As String = ""
            Dim err As be.business.connector.core.exceptions.IntegrationModuleValidationException = TryCast(p1.GetException, be.business.connector.core.exceptions.IntegrationModuleValidationException)
            If err.getValidationErrors IsNot Nothing Then
                For i = 0 To err.getValidationErrors.size - 1
                    Dim item = err.getValidationErrors.get(i)
                    validationErrorsString &= item & vbCrLf
                Next
            End If
            MessageBox.Show(validationErrorsString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf TypeOf p1.GetException Is be.business.connector.core.exceptions.IntegrationModuleException Then
            Dim errorsString As String = ""
            Dim err As be.business.connector.core.exceptions.IntegrationModuleException = TryCast(p1.GetException, be.business.connector.core.exceptions.IntegrationModuleException)
            '' errorsString &= err.getMessage & vbCrLf
            If err.getMessages IsNot Nothing Then
                For i = 0 To err.getMessages.size - 1
                    Dim localString As be.recipe.services.core.LocalisedString = err.getMessages.get(i)
                    If localString.getLang().toString = "EN" Then
                        errorsString &= localString.getValue() & vbCrLf
                    End If
                Next
            End If
            If err.getMessage IsNot Nothing And err.getMessages IsNot Nothing And err.getMessages.size = 0 Then
                errorsString &= "Error: " & err.getMessage & vbCrLf
            End If
            If err.getMessageCode IsNot Nothing Then
                errorsString &= "ErrorCode: " & err.getMessageCode & vbCrLf
            End If
            If err.getPrescriptionStatus IsNot Nothing Then
                errorsString &= "PrescriptionStatus: " & err.getPrescriptionStatus.toString & vbCrLf
            End If
            If err.getStatusUpdater IsNot Nothing Then
                errorsString &= "StatusUpdater: " & err.getStatusUpdater & vbCrLf
            End If
            MessageBox.Show(errorsString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            If Not String.IsNullOrEmpty(p1.Description) Then
                MessageBox.Show(p1.Description, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub



    Private Sub MarkAsDeliveredButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsDeliveredButton.Click
        'boolean ExecutorV3
        On Error GoTo ERR

        MarkAsDeliveredButton.Enabled = False

        GetRecipeModule(ExecutorV3.Checked).markAsDelivered(GetPrescriptionRID.Text)

        MessageBox.Show("Prescription successfully marked as delivered!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsDeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsDeliveredButton.Enabled = True
    End Sub

    Private Sub MarkAsUndeliveredButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsUndeliveredButton.Click
        'boolean ExecutorV3
        On Error GoTo ERR

        MarkAsUndeliveredButton.Enabled = False

        GetRecipeModule(ExecutorV3.Checked).markAsUndelivered(GetPrescriptionRID.Text)

        MessageBox.Show("Prescription successfully marked as undelivered!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsUndeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsUndeliveredButton.Enabled = True
    End Sub

    Private Sub MarkAsArchivedButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkAsArchivedButton.Click
        'boolean ExecutorV3
        On Error GoTo ERR

        MarkAsArchivedButton.Enabled = False

        GetRecipeModule(ExecutorV3.Checked).markAsArchived(GetPrescriptionRID.Text)

        MessageBox.Show("Prescription successfully marked as archived!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MarkAsArchivedButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        MarkAsArchivedButton.Enabled = True
    End Sub
    Private Sub RevokeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RevokeButton.Click
        'boolean ExecutorV3
        On Error GoTo ERR

        RevokeButton.Enabled = False

        GetRecipeModule(ExecutorV3.Checked).revokePrescription(GetPrescriptionRID.Text, InputBox("Revoke Reason:"))

        MessageBox.Show("Prescription " & GetPrescriptionRID.Text & " successfully revoked!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        RevokeButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        RevokeButton.Enabled = True
    End Sub
    Private Sub CreateFeedbackBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateFeedbackBtn.Click
        'boolean ExecutorV3_1
        On Error GoTo ERR

        CreateFeedbackBtn.Enabled = False

        Dim feedback As Byte()
        Dim encoding As New System.Text.UTF8Encoding()
        feedback = encoding.GetBytes(CreateFeedbackContent.Text)


        GetRecipeModule(ExecutorV3_1.Checked).createFeedback(Long.Parse(CreateFeedbackPrescriber.Text),
                                                 CreateFeedbackRID.Text,
                                                 feedback)

        MessageBox.Show("Feedback created!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        CreateFeedbackBtn.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        CreateFeedbackBtn.Enabled = True
    End Sub

    Private Sub ListNotificationsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListNotificationsButton.Click
        'boolean ExecutorV3_2
        On Error GoTo ERR

        ListNotificationsButton.Enabled = False

        Dim i As Integer
        Dim notifications As java.util.List
        Dim item As ListNotificationsItem

        notifications = GetRecipeModule(ExecutorV3_2.Checked).listNotifications(Not (ListNotificationsUnreadCheckBox.Checked))

        ListNotificationsResult.Text = ""
        If notifications IsNot Nothing Then
            For i = 0 To notifications.size - 1
                item = notifications.get(i)
                ListNotificationsResult.Text &= "=================================================" & vbCrLf
                ListNotificationsResult.Text &= "Sent by : " + item.getSentBy.ToString & vbCrLf
                If item.getSentDate IsNot Nothing Then
                    ListNotificationsResult.Text &= "Sent date : " + New java.text.SimpleDateFormat("yyyy-MM-dd").format(item.getSentDate) & vbCrLf
                End If
                ListNotificationsResult.Text &= "-------------------------------------------------" & vbCrLf
                ListNotificationsResult.Text &= IOUtils.strConvert(item.getContent) & vbCrLf
                ListNotificationsResult.Text &= "-------------------------------------------------" & vbCrLf
            Next
        End If
        ListNotificationsButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        ListNotificationsButton.Enabled = True
    End Sub

    Private Sub btnGetInsurability_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetInsurability.Click
        'boolean version2
        On Error GoTo ERR

        btnGetInsurability.Enabled = False

        Dim insurability As be.business.connector.mycarenet.domain.Insurability

        insurability = GetMyCareNetModule(version2.Checked).getInsurabilityForPharmacist(insUsername.Text, insPassword.Text,
                                                            insPharmacyHolder.Text, insPharmacistSSIN.Text, insPharmacyNihii.Text,
                                                             insDate.Text, insType.Text, insPatient.Text, txtMutuality.Text, txtRegNrWithMu.Text,
                                                             insPakgName.Text, insReference.Text,
                                                             insUserReference.Text)
        If (IsDBNull(insurability)) Then
            MessageBox.Show("No Insurability!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            InsurabilityXml.Text = insurability.getXml
            lblMessageId.Text = insurability.getMessageId
        End If

        btnGetInsurability.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        btnGetInsurability.Enabled = True
    End Sub

    Private Sub btnMandatePersonal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMandatePersonal.Click
        On Error GoTo ERR

        btnMandatePersonal.Enabled = False
        rtbMandateResponse.Text = createNewSession(SessionType.MANDATE_SESSION, Nothing, Nothing)
        btnMandatePersonal.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        btnMandatePersonal.Enabled = True
    End Sub


    Private Sub btnSystemKeystoreSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSystemKeystoreSave.Click
        On Error GoTo ERR
        btnSystemKeystoreSave.Enabled = False

        ApplicationConfig.getInstance().setSystemKeystoreProperties(txtSystemKeystorePass.Text, txtSystemKeystoreFile.Text, txtSystemkeystoreDir.Text, txtSystemkeystoreKboRiziv.Text)

        MessageBox.Show("System keystore information has been saved.")

        btnSystemKeystoreSave.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        btnSystemKeystoreSave.Enabled = True
    End Sub

    Private Sub btnOldSystemkeystoreSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOldSystemkeystoreSave.Click
        On Error GoTo ERR
        btnOldSystemkeystoreSave.Enabled = False

        ApplicationConfig.getInstance().setOldSystemKeystoreProperties(txtOldSystemKeystorePass.Text, txtOldSystemKeystoreFile.Text, txtOldSystemkeystoreDir.Text, txtOldSystemkeystoreKboRiziv.Text)

        MessageBox.Show("Previous System keystore information has been saved.")

        btnOldSystemkeystoreSave.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        btnOldSystemkeystoreSave.Enabled = True
    End Sub


    Private Sub btnCreateSession_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateSession.Click
        On Error GoTo ERR

        btnCreateSession.Enabled = False
        txtSamlToken.Text = createNewSession(SessionType.EID_SESSION, Nothing, Nothing)
        btnCreateSession.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        btnCreateSession.Enabled = True
    End Sub

    Private Sub btnFallbackSession_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFallbackSession.Click
        On Error GoTo ERR

        btnFallbackSession.Enabled = False

        If PasswordPrompt.ShowDialog() = DialogResult.OK Then
            txtSamlToken.Text = createNewSession(SessionType.FALLBACK_SESSION, PasswordPrompt.niss.Text, PasswordPrompt.password.Text)
        End If
        ' use the data from the configuration file instead of user-defined values
        btnFallbackSession.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        btnFallbackSession.Enabled = True
    End Sub

    Private Sub btnGfdDppRegisterData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGfdDppRegisterData.Click
        On Error GoTo ERR
        btnGfdDppRegisterData.Enabled = False
        'byte[] singleMessage, String tipId, boolean requestPatientSignature, Boolean patientConsent



        If rbtRegisterPatientConsentYes.Checked = True Then

            txtRegisterResponse.Text = GetTIPSystemModule().registerData(IOUtils.toByte(txtRegisterSingleMessage.Text), txtRegisterTip.Text, chkRegisterRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtRegisterDataPatientConsentNo.Checked = True Then

            txtRegisterResponse.Text = GetTIPSystemModule().registerData(IOUtils.toByte(txtRegisterSingleMessage.Text), txtRegisterTip.Text, chkRegisterRequestPatientSignature.Checked, ThreeStateBoolean.FALSE)
        End If
        If rbtRegisterDataUnknown.Checked = True Then

            txtRegisterResponse.Text = GetTIPSystemModule().registerData(IOUtils.toByte(txtRegisterSingleMessage.Text), txtRegisterTip.Text, chkRegisterRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If

        btnGfdDppRegisterData.Enabled = True
        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGfdDppRegisterData.Enabled = True
    End Sub

    Private Sub btnGetDataTypes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetDataTypes.Click
        'String patientIdType, String patientId, boolean requestPatientSignature, Boolean therapeuticRelationShip
        On Error GoTo ERR

        btnGetDataTypes.Enabled = False

        If rbtGetDataTypesTherapeuticalRelationShipYes.Checked = True Then
            txtGetDataTypesResponse.Text = GetPCDHModule().getDataTypes(txtGetDataTypesPatientIdType.Text, txtGetDataTypesPatientId.Text, chkGetDataTypesRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtGetDataTypesTherapeuticalRelationShipNo.Checked = True Then
            txtGetDataTypesResponse.Text = GetPCDHModule().getDataTypes(txtGetDataTypesPatientIdType.Text, txtGetDataTypesPatientId.Text, chkGetDataTypesRequestPatientSignature.Checked, ThreeStateBoolean.FALSE)
        End If
        If rbtGetDataTypesTherapeuticalRelationShipUnknown.Checked = True Then
            txtGetDataTypesResponse.Text = GetPCDHModule().getDataTypes(txtGetDataTypesPatientIdType.Text, txtGetDataTypesPatientId.Text, chkGetDataTypesRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If

        btnGetDataTypes.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetDataTypes.Enabled = True

    End Sub

    Private Sub btnGetStatusMessages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetStatusMessages.Click
        On Error GoTo ERR

        btnGetStatusMessages.Enabled = False

        txtGetStatusMessagesResponse.Text = GetTIPSystemModule().getStatusMessages(txtGetStatusMessagesSguid.Text, txtGetStatusMessagesDguid.Text)

        btnGetStatusMessages.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetStatusMessages.Enabled = True
    End Sub

    Private Sub btnGetData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetData.Click
        On Error GoTo ERR
        btnGetData.Enabled = False


        If rbtGetDataTherapeuticalRelationShipYes.Checked = True Then
            txtGetDataResponse.Text = GetPCDHModule().getData(txtGetDataPatientIdType.Text, txtGetDataPatientId.Text, txtGetDataDataType.Text, txtGetDataDateRange.Text, chkExcludeOwnData.Checked, IOUtils.toByte(txtGetDataLocalData.Text), chkGetDataRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtGetDataTherapeuticalRelationShipNo.Checked = True Then

            txtGetDataResponse.Text = GetPCDHModule().getData(txtGetDataPatientIdType.Text, txtGetDataPatientId.Text, txtGetDataDataType.Text, txtGetDataDateRange.Text, chkExcludeOwnData.Checked, IOUtils.toByte(txtGetDataLocalData.Text), chkGetDataRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)


        End If
        If rbtGetDataTherapeuticalRelationShipUnknown.Checked = True Then
            txtGetDataResponse.Text = GetPCDHModule().getData(txtGetDataPatientIdType.Text, txtGetDataPatientId.Text, txtGetDataDataType.Text, txtGetDataDateRange.Text, chkExcludeOwnData.Checked, IOUtils.toByte(txtGetDataLocalData.Text), chkGetDataRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If

        btnGetData.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetData.Enabled = True
    End Sub

    Private Sub cmdUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUpdate.Click
        On Error GoTo ERR
        cmdUpdate.Enabled = False
        'byte[] singleMessage, String tipId, boolean requestPatientSignature, Boolean patientConsent

        If rbtRegisterPatientConsentYes.Checked = True Then
            txtUpdateDataResponse.Text = GetTIPSystemModule().updateData(IOUtils.toByte(txtUpdateSingleMessage.Text), txtUpdateTip.Text, chkUpdateRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtRegisterDataPatientConsentNo.Checked = True Then
            txtUpdateDataResponse.Text = GetTIPSystemModule().updateData(IOUtils.toByte(txtUpdateSingleMessage.Text), txtUpdateTip.Text, chkUpdateRequestPatientSignature.Checked, ThreeStateBoolean.FALSE)
        End If
        If rbtRegisterDataUnknown.Checked = True Then
            txtUpdateDataResponse.Text = GetTIPSystemModule().updateData(IOUtils.toByte(txtUpdateSingleMessage.Text), txtUpdateTip.Text, chkUpdateRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If

        cmdUpdate.Enabled = True
        Exit Sub

ERR:
        showError(Err)
OUT:
        cmdUpdate.Enabled = True
    End Sub

    Private Sub btnGfdDppRevoke_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGfdDppRevoke.Click
        On Error GoTo ERR
        btnGfdDppRevoke.Enabled = False

        If rbtRevokePatientConsentYes.Checked = True Then
            GetTIPSystemModule().revokeData(IOUtils.toByte(txtRevokeSingleMessage.Text), txtRevokeTip.Text, chkRevokeRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtRevokePatientConsentNo.Checked = True Then
            GetTIPSystemModule().revokeData(IOUtils.toByte(txtRevokeSingleMessage.Text), txtRevokeTip.Text, chkRevokeRequestPatientSignature.Checked, ThreeStateBoolean.FALSE)
        End If
        If rbtRevokePatientConsentUnknown.Checked = True Then
            GetTIPSystemModule().revokeData(IOUtils.toByte(txtRevokeSingleMessage.Text), txtRevokeTip.Text, chkRevokeRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If
        MessageBox.Show("Data has been revoked!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        btnGfdDppRevoke.Enabled = True
        Exit Sub

ERR:
        showError(Err)
        btnGfdDppRevoke.Enabled = True
    End Sub

    Private Sub btnGetPharmacyDetails_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetPharmacyDetails.Click

        'String patientIdType,String patientId, String dGuid, String motivationType,String motivationText, boolean requestPatientSignature, Boolean therapeuticRelationShip
        On Error GoTo ERR
        btnGetPharmacyDetails.Enabled = False

        If rbtGetPharmacyDetailsTherapeuticalRelationShipYes.Checked = True Then
            txtGetPharmacyDetailsResponse.Text = GetPCDHModule().getPharmacyDetails(txtGetPharmacyDetailsPatientIdType.Text, txtGetPharmacyDetailsPatientId.Text, txtGetPharmacyDetailsDGuid.Text, txtGetPharmacyDetailsMotivationType.Text, txtGetPharmacyDetailsMotivation.Text, chkGetPharmacyDetailsRequestPatientSignature.Checked, ThreeStateBoolean.TRUE)
        End If
        If rbtGetPharmacyDetailsTherapeuticalRelationShipNo.Checked = True Then
            txtGetPharmacyDetailsResponse.Text = GetPCDHModule().getPharmacyDetails(txtGetPharmacyDetailsPatientIdType.Text, txtGetPharmacyDetailsPatientId.Text, txtGetPharmacyDetailsDGuid.Text, txtGetPharmacyDetailsMotivationType.Text, txtGetPharmacyDetailsMotivation.Text, chkGetPharmacyDetailsRequestPatientSignature.Checked, ThreeStateBoolean.FALSE)
        End If
        If rbtGetPharmacyDetailsTherapeuticalRelationShipUnknown.Checked = True Then
            txtGetPharmacyDetailsResponse.Text = GetPCDHModule().getPharmacyDetails(txtGetPharmacyDetailsPatientIdType.Text, txtGetPharmacyDetailsPatientId.Text, txtGetPharmacyDetailsDGuid.Text, txtGetPharmacyDetailsMotivationType.Text, txtGetPharmacyDetailsMotivation.Text, chkGetPharmacyDetailsRequestPatientSignature.Checked, ThreeStateBoolean.NULL)
        End If

        btnGetPharmacyDetails.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetPharmacyDetails.Enabled = True
    End Sub


    Private Sub GetPrescriptionButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetPrescriptionButton.Click
        'boolean ExecutorV3
        On Error GoTo ERR

        GetPrescriptionButton.Enabled = False
        GetprescriptionContent.Clear()
        GetPrescriptionPrescriber.Clear()
        GetPrescriptionPatient.Clear()
        GetprescriptionContent.Clear()
        ExpirationDateTextBox.Clear()

        Dim p As GetPrescriptionForExecutorResult

        p = GetRecipeModule(ExecutorV3.Checked).getPrescription(GetPrescriptionRID.Text)

        GetPrescriptionDate.Text = p.getCreationDate().getTime.toString
        GetPrescriptionPrescriber.Text = p.getPrescriberId()
        GetPrescriptionPatient.Text = p.getPatientId()
        GetprescriptionContent.Text = IOUtils.strConvert(p.getPrescription())
        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        Dim expirationDateString As String = ""
        If p.getExpirationDate IsNot Nothing Then
            expirationDateString = simpleDateFormat.format(p.getExpirationDate.getTime)
            ExpirationDateTextBox.Text = expirationDateString
        End If
        If (IsDBNull(p.getInsurabilityResponse())) Then
            MessageBox.Show("No Insurability!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            txtInsurabilityOrchestration.Text = p.getInsurabilityResponse()
        End If
        feedbackCheckbox.Checked = p.isFeedbackAllowed()

        CreateFeedbackRID.Text = GetPrescriptionRID.Text
        CreateFeedbackPrescriber.Text = p.getPrescriberId().ToString

        GetPrescriptionButton.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        GetPrescriptionButton.Enabled = True
    End Sub

    Private Sub ExecutorTool_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        On Error GoTo ERR
        GetRecipeModule(False)
        Exit Sub
ERR:
        showError(Err)
    End Sub

    Private Sub ExecutorTool_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If initTIPSystem = True Then
            GetTIPSystemModule.shutdownGracefully()
        End If

    End Sub

    Private Sub btnConsult_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConsult.Click

        On Error GoTo ERR
        Dim xmlResourceInputStream As InputStream

        performTestConsultation()
        Exit Sub
ERR:
        showError(Err)

    End Sub

    Private Function parseFolderType(ByVal xmlResourceString As String) As FolderType
        On Error GoTo ERR

        Dim jaxContextCentralizer As be.apb.gfddpp.common.utils.JaxContextCentralizer
        Dim f As FolderType
        f = New FolderType

        Return be.apb.gfddpp.common.utils.JaxContextCentralizer.getInstance().toObject(f.getClass, IOUtils.toByte(xmlResourceString))
        Exit Function

ERR:
        showError(Err)

    End Function


    Private Sub performTestConsultation()
        On Error GoTo ERR
        Dim service As ChapterIVService
        Dim folder As FolderType
        Dim builderResponse As ChapterIVBuilderResponse
        Dim response As ConsultChap4MedicalAdvisorAgreementResponse
        Dim retrievedKmehrResponse As ChapterIVKmehrResponseWithTimeStampInfo
        Dim responseBuilder As ResponseBuilder
        Dim patientInss As String

        responseBuilder = BuilderFactory.getBuilderFactoryForSession().getResponseBuilder()

        service = ChapterIVSessionServiceFactory.getChapterIVService()

        folder = parseFolderType(txtConsultRequest.Text)

        patientInss = txtConsultPatientId.Text
        folder = updateFolderWithAuthorAndCurrentDate(folder, patientInss)

        Dim builder As ConsultationBuilder
        Dim references As ChapterIVReferences
        Dim agreementStartDate As org.joda.time.DateTime

        agreementStartDate = FolderTypeUtils.retrieveConsultationStartDateOrAgreementStartDate(folder)

        references = New ChapterIVReferences(True)

        builder = BuilderFactory.getBuilderFactoryForSession().getConsultationBuilder()

        builderResponse = builder.build(folder, True, references, agreementStartDate)

        response = service.consultChap4MedicalAdvisorAgreement(builderResponse.getConsultChap4MedicalAdvisorAgreementRequest())

        retrievedKmehrResponse = responseBuilder.validateTimestampAndretrieveChapterIVKmehrResponseWithTimeStampInfo(response)

        txtConsultResponse.Text = ""
        txtConsultResponse.Text = JaxContextCentralizer.getInstance().toXml(retrievedKmehrResponse.getKmehrresponse().getClass, retrievedKmehrResponse.getKmehrresponse())

        Exit Sub
ERR:
        showError(Err)


    End Sub
    Public Function updateFolderWithAuthorAndCurrentDate(ByVal folder As FolderType, ByVal patientInss As String) As FolderType
        If (IsDBNull(folder)) Then

        Else

            For value As Integer = 0 To (folder.getTransactions().size() - 1)

                Dim transaction As TransactionType
                transaction = CType(folder.getTransactions().get(value), TransactionType)
                Dim authorType As New AuthorType
                authorType.getHcparties().add(HcPartyUtil.createProfessionalParty(PropertyHandler.getInstance().getProperty("pharmacy-holder.ssin"), PropertyHandler.getInstance().getProperty("pharmacy-holder.nihii"), PropertyHandler.getInstance().getProperty("main.kmehr.quality")))
                transaction.setAuthor(authorType)
                transaction.setDate(New org.joda.time.DateTime())
                transaction.setTime(New org.joda.time.DateTime())
            Next

            For value As Integer = 0 To (folder.getPatient().getIds().size() - 1)

                Dim idPatient As be.fgov.ehealth.standards.kmehr.id.v1.IDPATIENT
                idPatient = CType(folder.getPatient().getIds().get(value), be.fgov.ehealth.standards.kmehr.id.v1.IDPATIENT)
                idPatient.setValue(patientInss)
            Next


        End If
        Return folder
    End Function
    Private Sub btnArchivePrescriptionMessages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnArchivePrescriptionMessages.Click
        On Error GoTo ERR

        btnArchivePrescriptionMessages.Enabled = False

        txtGetArchivePrescriptionResponse.Text = GetTIPSystemModule().archivePrescription(txtGetArchivePrescriptionRid.Text)

        btnArchivePrescriptionMessages.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnArchivePrescriptionMessages.Enabled = True
    End Sub

    Private Sub btnArchivePrescriptionCommentMessages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnArchivePrescriptionCommentMessages.Click
        On Error GoTo ERR

        btnArchivePrescriptionCommentMessages.Enabled = False

        txtAddArchivePrescriptionCommentResponse.Text = GetTIPSystemModule().archivePrescriptionComment(txtArchivePrescriptionCommentRid.Text, txtArchivePrescriptionCommentComments.Text)

        btnArchivePrescriptionCommentMessages.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnArchivePrescriptionCommentMessages.Enabled = True
    End Sub

    Private Sub btnRegisterMedicationSchemeEntries_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRegisterMedicationSchemeEntries.Click
        On Error GoTo ERR
        btnRegisterMedicationSchemeEntries.Enabled = False

        Dim request As StoreDataEntriesRequest
        Dim response As StoreDataEntriesResponse
        request = New StoreDataEntriesRequest

        request = JaxContextCentralizer.getInstance().toObject(request.getClass, txtStoreDataEntriesRequest.Text)
        response = GetTIPSystemModule().registerMedicationSchemeEntries(request)
        txtStoreDataEntriesResponse.Text = JaxContextCentralizer.getInstance().toXml(response.getClass, response)
        btnRegisterMedicationSchemeEntries.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnRegisterMedicationSchemeEntries.Enabled = True
    End Sub

    Private Sub btnGetMedicationSchemeTimestamps_Click(sender As Object, e As EventArgs) Handles btnGetMedicationSchemeTimestamps.Click
        On Error GoTo ERR
        btnGetMedicationSchemeTimestamps.Enabled = False

        Dim request As RetrieveTimestampsRequest
        Dim response As RetrieveTimestampsResponse
        request = New RetrieveTimestampsRequest

        request = JaxContextCentralizer.getInstance().toObject(request.getClass, txtRetrieveTimestampsRequest.Text)
        response = GetPCDHModule().getMedicationSchemeTimestamps(request)
        txtRetrieveTimestampsResponse.Text = JaxContextCentralizer.getInstance().toXml(response.getClass, response)
        btnGetMedicationSchemeTimestamps.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetMedicationSchemeTimestamps.Enabled = True

    End Sub

    Private Sub btnGetMedicationSchemeEntries_Click(sender As Object, e As EventArgs) Handles btnGetMedicationSchemeEntries.Click
        On Error GoTo ERR
        btnGetMedicationSchemeEntries.Enabled = False

        Dim request As FetchDataEntriesRequest
        Dim response As FetchDataEntriesResponse
        request = New FetchDataEntriesRequest

        request = JaxContextCentralizer.getInstance().toObject(request.getClass, txtFetchDataEntriesRequest.Text)
        response = GetPCDHModule().getMedicationSchemeEntries(request)
        txtFetchDataEntriesResponse.Text = JaxContextCentralizer.getInstance().toXml(response.getClass, response)
        btnGetMedicationSchemeEntries.Enabled = True

        Exit Sub

ERR:
        showError(Err)
OUT:
        btnGetMedicationSchemeEntries.Enabled = True

    End Sub

    Private Sub GetOpenPrescriptionsListButton_Click(sender As Object, e As EventArgs) Handles GetOpenPrescriptionsListButton.Click
        On Error GoTo ERR
        DisableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsList()
        EnableGetOpenPrescriptionsListButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Private Sub EnableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsListButton.Enabled = True
        'PreviousPageButton.Enabled = True
        PutInProcessButton.Enabled = True
        If listOpenPrescriptionsListPageNumber = 0 Then
            NextPageButton.Enabled = False
        Else
            NextPageButton.Enabled = True
        End If
    End Sub

    Private Sub DisableGetOpenPrescriptionsListButtons()
        GetOpenPrescriptionsListButton.Enabled = False
        NextPageButton.Enabled = False
        PreviousPageButton.Enabled = False
        PutInProcessButton.Enabled = False
    End Sub

    Private Sub GetOpenPrescriptionsListView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles GetOpenPrescriptionsListView.CellContentClick
        On Error GoTo ERR
        Dim colName As String = GetOpenPrescriptionsListView.Columns(e.ColumnIndex).Name
        If colName = "ViewColumn" Then
            Dim currentValue = GetOpenPrescriptionsListView.CurrentRow.Cells("RIDColumn").Value
            If GetOpenPrescriptionsResult.getPrescriptions IsNot Nothing Then
                For i = 0 To GetOpenPrescriptionsResult.getPrescriptions.size - 1
                    Dim item As be.recipe.services.executor.GetOpenPrescriptionForExecutor = GetOpenPrescriptionsResult.getPrescriptions.get(i)
                    If item.getRid = currentValue Then
                        Dim decryptedItem As be.recipe.services.executor.GetOpenPrescriptionForExecutor = GetRecipeModule(False).decryptGetOpenPrescriptionForExecutor(item)
                        PopupDialog.richTextBoxMessage.Text = Encoding.UTF8.GetString(decryptedItem.getPrescription)
                        PopupDialog.richTextBoxMessage.Refresh()
                        PopupDialog.ShowDialog()
                    End If
                Next
            End If
        End If
        Exit Sub

ERR:
        showError(Err)
    End Sub

    Private Sub PutInProcessButton_Click(sender As Object, e As EventArgs) Handles PutInProcessButton.Click
        On Error GoTo ERR
        DisableGetOpenPrescriptionsListButtons()
        Dim Rids = GetCheckedRows(Me.GetOpenPrescriptionsListView, 6)
        If Rids.Count > 0 Then
            Dim value As String = String.Join(",", Rids)
            Dim param As be.recipe.services.executor.PutRidsInProcessParam = New be.recipe.services.executor.PutRidsInProcessParam
            Dim javaList As java.util.List = New java.util.ArrayList
            Dim str As String
            For Each str In Rids
                javaList.add(str)
            Next
            param.getRids().addAll(javaList)
            Dim response As be.recipe.services.executor.PutRidsInProcessResult = GetRecipeModule(False).putData(param)
            If response.getStatus.getCode = 100 Then
                GetOpenPrescriptionsList()
            Else
                Dim errorList As java.util.List = response.getStatus.getMessages()
                If errorList IsNot Nothing Then
                    For i = 0 To errorList.size - 1
                        Dim localString As be.recipe.services.core.LocalisedString = errorList.get(i)
                        If localString.getLang().toString = "EN" Then
                            MessageBox.Show(localString.getValue())
                        End If
                    Next
                End If
            End If

        Else
            MessageBox.Show("No rows selected to put in process")
        End If
        EnableGetOpenPrescriptionsListButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Function GetCheckedRows(grid As DataGridView, checkboxColumnIndex As Integer) As List(Of String)
        Dim checkedRows As New List(Of DataGridViewRow)
        Dim Rids As New List(Of String)
        For rowIndex As Integer = 0 To grid.RowCount - 1
            Dim chkCell = TryCast(grid(checkboxColumnIndex, rowIndex), DataGridViewCheckBoxCell)
            Dim isChecked As Boolean = CBool(chkCell.EditedFormattedValue)
            If isChecked Then
                checkedRows.Add(grid.Rows(rowIndex))
                Rids.Add(grid.Rows(rowIndex).Cells("RIDColumn").Value)
            End If

        Next
        Return Rids
    End Function

    Private Sub PreviousMonthButton_Click(sender As Object, e As EventArgs) Handles PreviousPageButton.Click
        On Error GoTo ERR
        listOpenPrescriptionsListPageNumber = listOpenPrescriptionsListPageNumber + 1
        If listOpenPrescriptionsListPageNumber = 0 Then
            NextPageButton.Enabled = False
        Else
            NextPageButton.Enabled = True
        End If
        GetOpenPrescriptionsList()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Private Sub NextMonthButton_Click(sender As Object, e As EventArgs) Handles NextPageButton.Click
        On Error GoTo ERR
        listOpenPrescriptionsListPageNumber = listOpenPrescriptionsListPageNumber - 1
        GetOpenPrescriptionsList()
        Exit Sub
ERR:
        showError(Err)
        EnableGetOpenPrescriptionsListButtons()
    End Sub

    Function GetOpenPrescriptionsList() As be.recipe.services.executor.ListOpenPrescriptionsResult
        'On Error GoTo ERR
        DisableGetOpenPrescriptionsListButtons()
        ListOpenPrescriptionsPageNumberLabel.Text = "Page: " & listOpenPrescriptionsListPageNumber
        Dim param As be.recipe.services.executor.ListOpenPrescriptionsParam = New be.recipe.services.executor.ListOpenPrescriptionsParam
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(listOpenPrescriptionsListPageNumber)
        Page.setPageNumber(bi)
        param.setPage(Page)
        param.setPatientId(ListOpenPrescriptionsPatientIdTextBox.Text)
        param.setMandateHolderId(ListOpenPrescriptionsMandateHolderTextBox.Text)

        GetOpenPrescriptionsResult = GetRecipeModule(False).getData(param)
        GetOpenPrescriptionsListView.Rows.Clear()
        If GetOpenPrescriptionsResult.getPrescriptions IsNot Nothing Then
            For i = 0 To GetOpenPrescriptionsResult.getPrescriptions.size - 1
                Dim item As be.recipe.services.executor.GetOpenPrescriptionForExecutor = GetOpenPrescriptionsResult.getPrescriptions.get(i)
                Dim pattern = "yyyy-MM-dd"
                Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
                Dim expirationDate As java.util.Calendar = item.getExpirationDate
                Dim expirationDateString As String = ""
                If expirationDate IsNot Nothing Then
                    expirationDateString = simpleDateFormat.format(expirationDate.getTime())
                End If
                Dim status As String = item.getPrescriptionStatus.name

                GetOpenPrescriptionsListView.Rows.Add(item.getRid, item.getPrescriberId, simpleDateFormat.format(item.getCreationDate.getTime()), expirationDateString, status)

                If GetOpenPrescriptionsResult.getHasMoreResults.booleanValue Then
                    PreviousPageButton.Enabled = True
                Else
                    PreviousPageButton.Enabled = False
                End If

            Next
        Else
            GetOpenPrescriptionsListView.Rows.Clear()
        End If
        EnableGetOpenPrescriptionsListButtons()
        Return GetOpenPrescriptionsResult
        'Exit Function
        'ERR:'
        'showError(Err)
        ' EnableGetOpenPrescriptionsListButtons()
    End Function

    Private Sub GetAllReservationsButton_Click(sender As Object, e As EventArgs) Handles GetAllReservationsButton.Click
        On Error GoTo ERR
        'GetAllReservationsRichTextBox.Text = ""

        GetAllReservationsButton.Enabled = False

        Dim param As be.recipe.services.executor.ListReservationsParam = New be.recipe.services.executor.ListReservationsParam

        ListReservationsResult = GetRecipeModule(False).getData(param)
        ListReservationsDataGridView.Rows.Clear()

        'If response.getItems IsNot Nothing Then
        'For i = 0 To response.getItems.size - 1
        ' Dim item As be.recipe.services.executor.ListReservationsResultItem = response.getItems.get(i)
        ' 'GetAllReservationsRichTextBox.Text &= "" & item.getRid & vbCrLf
        ' Next
        ' End If
        If ListReservationsResult.getItems IsNot Nothing Then
            For i = 0 To ListReservationsResult.getItems.size - 1
                Dim item As be.recipe.services.executor.ListReservationsResultItem = ListReservationsResult.getItems.get(i)
                ListReservationsDataGridView.Rows.Add(item.getRid, item.getPrescriberId, item.getExecutorId, item.getPatientId,
                  DateToString(item.getCreationDateReservation), DateToString(item.getLastUpdateReservation), DateToString(item.getCreationDate),
                  DateToString(item.getExpirationDate), item.getPrescriptionStatus)
            Next

        End If

        GetAllReservationsButton.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        GetAllReservationsButton.Enabled = True
    End Sub

    Private Function DateToString(dateValue As java.util.Calendar) As String
        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        If dateValue IsNot Nothing Then
            Return simpleDateFormat.format(dateValue.getTime)
        End If
        Return ""
    End Function
    Private Sub GetRidInProcessButton_Click(sender As Object, e As EventArgs) Handles GetRidInProcessButton.Click
        On Error GoTo ERR
        DisableGetRidInProcessButtons()
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnableGetRidInProcessButtons()
    End Sub

    Private Sub GetRidInProcess()
        On Error GoTo ERR
        GetRidInProcessRichTextBox.Text = ""
        DisableGetRidInProcessButtons()
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        ListRidsInProcessPageNumberLabel.Text = "Page: " & listRidsInProcessPageNumber
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(listRidsInProcessPageNumber)
        Page.setPageNumber(bi)

        Dim param As be.recipe.services.executor.ListRidsInProcessParam = New be.recipe.services.executor.ListRidsInProcessParam
        param.setPage(Page)

        Dim response As be.recipe.services.executor.ListRidsInProcessResult = GetRecipeModule(False).getData(param)

        If response.getRids IsNot Nothing Then
            For i = 0 To response.getRids.size - 1
                Dim item = response.getRids.get(i)
                GetRidInProcessRichTextBox.Text &= "" & item & vbCrLf
            Next
        Else
            GetRidInProcessRichTextBox.Text = ""
        End If
        If response.getHasMoreResults.booleanValue Then
            GetRidsInProcessPreviousButton.Enabled = True
        Else
            GetRidsInProcessPreviousButton.Enabled = False
        End If
        EnableGetRidInProcessButtons()
        Exit Sub
ERR:
        showError(Err)
        EnableGetRidInProcessButtons()
    End Sub

    Private Sub DisableGetRidInProcessButtons()
        GetRidInProcessButton.Enabled = False
        GetRidsInProcessPreviousButton.Enabled = False
        GetRidsInProcessNextButton.Enabled = False
    End Sub

    Private Sub EnableGetRidInProcessButtons()
        GetRidInProcessButton.Enabled = True
        'GetRidsInProcessPreviousButton.Enabled = True
        If listRidsInProcessPageNumber = 0 Then
            GetRidsInProcessNextButton.Enabled = False
        Else
            GetRidsInProcessNextButton.Enabled = True
        End If
    End Sub

    Private Sub GetRidsInProcessPreviousButton_Click(sender As Object, e As EventArgs) Handles GetRidsInProcessPreviousButton.Click
        On Error GoTo ERR
        listRidsInProcessPageNumber = listRidsInProcessPageNumber + 1
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub GetRidsInProcessNextButton_Click(sender As Object, e As EventArgs) Handles GetRidsInProcessNextButton.Click
        On Error GoTo ERR
        listRidsInProcessPageNumber = listRidsInProcessPageNumber - 1
        GetRidInProcess()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub ListRidsHistoryButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryButton.Click
        On Error GoTo ERR
        DisabledListRidsHistoryButtons()
        ListRidsHistory()
        EnabledListRidsHistoryButtons()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub DisabledListRidsHistoryButtons()
        ListRidsHistoryButton.Enabled = False
        ListRidsHistoryPreviousPageButton.Enabled = False
        ListRidsHistoryNextPageButton.Enabled = False
    End Sub

    Private Sub EnabledListRidsHistoryButtons()
        ListRidsHistoryButton.Enabled = True
        'ListRidsHistoryPreviousPageButton.Enabled = True
        If ListRidsHistoryPageNumber = 0 Then
            ListRidsHistoryNextPageButton.Enabled = False
        Else
            ListRidsHistoryNextPageButton.Enabled = True
        End If
    End Sub





    Private Sub ListRidsHistory()
        ListRidsHistoryRichTextBox.Clear()
        DisabledListRidsHistoryButtons()
        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        ListRidsHistoryMonthLabel.Text = "Page: " & ListRidsHistoryPageNumber
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(ListRidsHistoryPageNumber)
        Page.setPageNumber(bi)

        Dim param As be.recipe.services.executor.ListRidsHistoryParam = New be.recipe.services.executor.ListRidsHistoryParam
        param.setPage(Page)
        param.setPatientId(ListRidsHistoryTextBox.Text)
        If ListRidsHistoryCheckBox.Checked Then
            param.setActiveResults(java.lang.Boolean.TRUE)
        Else
            param.setActiveResults(java.lang.Boolean.FALSE)
        End If



        Dim ListRidsHistoryResult As be.recipe.services.executor.ListRidsHistoryResult = GetRecipeModule(False).getData(param)

        If ListRidsHistoryResult.getItems() IsNot Nothing Then
            For i = 0 To ListRidsHistoryResult.getItems().size - 1
                Dim item As be.recipe.services.executor.ListRidsHistoryResultItem = ListRidsHistoryResult.getItems().get(i)
                ListRidsHistoryRichTextBox.Text &= item.getRid & ": " & item.getPrescriptionStatus.name & vbCrLf
            Next
        Else
            ListRidsHistoryRichTextBox.Clear()
        End If
        If ListRidsHistoryResult.getHasMoreResults.booleanValue Then
            ListRidsHistoryPreviousPageButton.Enabled = True
        Else
            ListRidsHistoryPreviousPageButton.Enabled = False
        End If

        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub ListRidsHistoryPreviousMonthButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryPreviousPageButton.Click
        On Error GoTo ERR
        ListRidsHistoryPageNumber = ListRidsHistoryPageNumber + 1
        ListRidsHistory()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub ListRidsHistoryNextMonthButton_Click(sender As Object, e As EventArgs) Handles ListRidsHistoryNextPageButton.Click
        On Error GoTo ERR
        ListRidsHistoryPageNumber = ListRidsHistoryPageNumber - 1
        ListRidsHistory()
        Exit Sub
ERR:
        showError(Err)
        EnabledListRidsHistoryButtons()
    End Sub

    Private Sub GetPrescriptionStatusButton_Click(sender As Object, e As EventArgs) Handles GetPrescriptionStatusButton.Click
        On Error GoTo ERR
        GetPrescriptionStatusButton.Enabled = False

        'Dim PrescriptionStatus As be.recipe.services.core.PrescriptionStatus
        Dim param As be.recipe.services.executor.GetPrescriptionStatusParam = New be.recipe.services.executor.GetPrescriptionStatusParam
        param.setRid(GetPrescriptionRID.Text)

        Dim result As be.recipe.services.executor.GetPrescriptionStatusResult = GetRecipeModule(ExecutorV3.Checked).getData(param)

        MessageBox.Show("PrescriptionStatus of prescription: " & GetPrescriptionRID.Text & " is: " & result.getPrescriptionStatus().name)

        GetPrescriptionStatusButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        GetPrescriptionStatusButton.Enabled = True
    End Sub

    Private Sub txtSamlToken_TextChanged(sender As Object, e As EventArgs) Handles txtSamlToken.TextChanged

    End Sub

    Private Sub GetAndMarkAsDeliveredButton_Click(sender As Object, e As EventArgs) Handles GetAndMarkAsDeliveredButton.Click
        On Error GoTo ERR
        GetAndMarkAsDeliveredButton.Enabled = False
        GetprescriptionContent.Clear()
        GetPrescriptionPrescriber.Clear()
        GetPrescriptionPatient.Clear()
        GetprescriptionContent.Clear()

        Dim p As be.business.connector.recipe.executor.domain.GetPrescriptionForExecutorResult = GetRecipeModule(ExecutorV3.Checked).getAndMarkAsDelivered(GetPrescriptionRID.Text)

        GetPrescriptionDate.Text = p.getCreationDate().getTime.toString
        GetPrescriptionPrescriber.Text = p.getPrescriberId()
        GetPrescriptionPatient.Text = p.getPatientId()
        GetprescriptionContent.Text = IOUtils.strConvert(p.getPrescription())

        Dim pattern = "yyyy-MM-dd"
        Dim simpleDateFormat As java.text.SimpleDateFormat = New java.text.SimpleDateFormat(pattern)
        Dim expirationDateString As String = ""
        If p.getExpirationDate IsNot Nothing Then
            expirationDateString = simpleDateFormat.format(p.getExpirationDate.getTime)
            ExpirationDateTextBox.Text = expirationDateString
        End If
        If (IsDBNull(p.getInsurabilityResponse())) Then
            MessageBox.Show("No Insurability!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            txtInsurabilityOrchestration.Text = p.getInsurabilityResponse()
        End If
        feedbackCheckbox.Checked = p.isFeedbackAllowed()

        CreateFeedbackRID.Text = GetPrescriptionRID.Text
        CreateFeedbackPrescriber.Text = p.getPrescriberId().ToString

        MessageBox.Show("GetAndMarkAsDelivered executed for prescription: " & p.getRid)

        GetAndMarkAsDeliveredButton.Enabled = True
        Exit Sub
ERR:
        showError(Err)
        GetAndMarkAsDeliveredButton.Enabled = True
    End Sub

    Private Sub ListMandatesButton_Click(sender As Object, e As EventArgs) Handles ListMandatesButton.Click
        On Error GoTo ERR
        ListMandates()

        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub DisabledListMandatesButtons()
        On Error GoTo ERR
        ListMandatesButton.Enabled = False
        ListMandatesNextPageButton.Enabled = False
        ListMandatesPreviousPageButton.Enabled = False

        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub EnabledListMandatesButtons()
        On Error GoTo ERR
        ListMandatesButton.Enabled = True
        ListMandatesNextPageButton.Enabled = True
        ListMandatesPreviousPageButton.Enabled = True

        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandatesNextPageButton_Click(sender As Object, e As EventArgs) Handles ListMandatesNextPageButton.Click
        On Error GoTo ERR
        listMandatesPageNumber = listMandatesPageNumber - 1
        ListMandates()
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandatesPreviousPageButton_Click(sender As Object, e As EventArgs) Handles ListMandatesPreviousPageButton.Click
        On Error GoTo ERR
        listMandatesPageNumber = listMandatesPageNumber + 1
        ListMandates()
        Exit Sub
ERR:
        showError(Err)
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListMandates()
        ListMandatesRichTextBox.Clear()
        DisabledListMandatesButtons()
        ListMandatesPageNumberLabel.Text = "Page: " & listMandatesPageNumber
        Dim param As be.recipe.services.executor.ListRelationsParam = New be.recipe.services.executor.ListRelationsParam
        param.setMandateHolderId(MandateHolderIdTextBox.Text)

        Dim Page As be.recipe.services.core.Page = New be.recipe.services.core.Page
        Dim bi As java.math.BigInteger
        bi = java.math.BigInteger.valueOf(listMandatesPageNumber)
        Page.setPageNumber(bi)
        param.setPage(Page)

        Dim response As be.recipe.services.executor.ListRelationsResult = GetRecipeModule(False).getData(param)

        If response.getItems IsNot Nothing Then
            For i = 0 To response.getItems.size - 1
                Dim item As be.recipe.services.executor.ListRelationsItem = response.getItems.get(i)
                ListMandatesRichTextBox.Text &= "" & item.getMandateHolderId & "   " & item.getPatientId & vbCrLf
            Next
        End If
        EnabledListMandatesButtons()
    End Sub

    Private Sub ListReservationsDataGridView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ListReservationsDataGridView.CellContentClick
        On Error GoTo ERR
        Dim colName As String = ListReservationsDataGridView.Columns(e.ColumnIndex).Name
        If colName = "ViewReservationColumn" Then
            Dim currentValue = ListReservationsDataGridView.CurrentRow.Cells("ReservationsRIDColumn").Value
            If ListReservationsResult.getItems IsNot Nothing Then
                For i = 0 To ListReservationsResult.getItems.size - 1
                    Dim item As be.recipe.services.executor.ListReservationsResultItem = ListReservationsResult.getItems.get(i)
                    If item.getRid = currentValue Then
                        Dim decryptedItem As be.recipe.services.executor.GetOpenPrescriptionForExecutor = GetRecipeModule(False).decryptGetOpenPrescriptionForExecutor(item.getPrescription)
                        PopupDialog.richTextBoxMessage.Text = Encoding.UTF8.GetString(decryptedItem.getPrescription)
                        PopupDialog.richTextBoxMessage.Refresh()
                        PopupDialog.ShowDialog()
                    End If
                Next
            End If
        End If
        Exit Sub

ERR:
        showError(Err)
    End Sub

End Class
