/**
 * Copyright (C) 2010 Recip-e
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package be.business.connector.core.handlers;

import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

import org.apache.log4j.Logger;

public class IdentityHandler implements SOAPHandler<SOAPMessageContext> {
	private final static Logger LOG = Logger.getLogger(IdentityHandler.class);
	private static String insurability;
	private static String messageId;

	/** {@inheritDoc} */
	public Set<QName> getHeaders() {
		return null;
	}

	/** {@inheritDoc} */
	public void close(MessageContext arg0) {
	}

	/** {@inheritDoc} */
	public boolean handleFault(SOAPMessageContext c) {
		handleMessage(c);
		return true;
	}

	/** {@inheritDoc} */
	public boolean handleMessage(SOAPMessageContext smc) {
		try {
			final Boolean outboundProperty = (Boolean) smc.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
			if (outboundProperty == true) {
				SOAPMessage message = smc.getMessage();

				try {

					SOAPEnvelope envelope = smc.getMessage().getSOAPPart().getEnvelope();
					SOAPHeader header = envelope.addHeader();

					// SOAPElement security = header.addChildElement("username", "wsse",
					// "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");
					//
					// SOAPElement usernameToken = header.addChildElement("UsernameToken", "wsse");
					// usernameToken.addAttribute(new QName("xmlns:wsu"),
					// "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd");

					SOAPElement username = header.addChildElement("Username", "wsse");
					username.addTextNode("username");

					SOAPElement password = header.addChildElement("Password", "wsse");
					// password.setAttribute("Type",
					// "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText");
					password.addTextNode("test321");

					message.saveChanges();

					// Print out the outbound SOAP message to System.out
					message.writeTo(System.out);
					System.out.println("");
				} catch (Throwable t) {
					LOG.warn("SOAPException when retrieving insurability the message", t);
				}
			}

		} catch (Throwable t) {
			LOG.warn("SOAPException when retrieving insurability the message", t);
		}
		return true;
	}

	public static void setMessageId(String messageId) {
		IdentityHandler.messageId = messageId;
	}

	public static String getMessageId() {
		return messageId;
	}

}