package be.business.connector.gfddpp.pcdh;

import be.business.connector.core.exceptions.IntegrationModuleException;
import be.business.connector.gfddpp.domain.ThreeStateBoolean;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.FetchDataEntriesRequest;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.FetchDataEntriesResponse;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.RetrieveTimestampsRequest;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.RetrieveTimestampsResponse;

public interface PCDHIntegrationModule {
    String getPharmacyDetails(String patientIdType, String patientId, String dGuid, String motivationType, String motivationText, boolean requestPatientSignature, ThreeStateBoolean therapeuticRelationShip) throws IntegrationModuleException;

    String getData(String patientIdType, String patientId, String dataType, String dateRange, boolean ExcludeOwnData, byte[] localData, boolean requestPatientSignature, ThreeStateBoolean therapeuticRelationShip) throws IntegrationModuleException;

    String getDataTypes(String patientIdType, String patientId, boolean requestPatientSignature, ThreeStateBoolean therapeuticRelationShip) throws IntegrationModuleException;

    RetrieveTimestampsResponse getMedicationSchemeTimestamps(final RetrieveTimestampsRequest retrieveTimestampsRequest) throws IntegrationModuleException;

    FetchDataEntriesResponse getMedicationSchemeEntries(final FetchDataEntriesRequest fetchDataEntriesRequest) throws IntegrationModuleException;

}
