package be.business.connector.gfddpp.tipsystem;

import be.business.connector.core.exceptions.IntegrationModuleException;
import be.business.connector.gfddpp.domain.ThreeStateBoolean;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.StoreDataEntriesRequest;
import be.business.connector.gfddpp.domain.medicationscheme.protocol.StoreDataEntriesResponse;

public interface TIPSystemIntegrationModule {

    String registerData(byte[] singleMessage, String tipId, boolean requestPatientSignature, ThreeStateBoolean patientConsent) throws IntegrationModuleException;

    StoreDataEntriesResponse registerMedicationSchemeEntries(StoreDataEntriesRequest request) throws IntegrationModuleException;

    void revokeData(byte[] singleMessage, String tipId, boolean requestPatientSignature, ThreeStateBoolean patientConsent) throws IntegrationModuleException;

    String updateData(byte[] singleMessage, String tipId, boolean requestPatientSignature, ThreeStateBoolean patientConsent) throws IntegrationModuleException;

    String getStatusMessages(String sGuid, String dGuid) throws IntegrationModuleException;

    void shutdownGracefully() throws IntegrationModuleException;

    public String archivePrescriptionComment(String rid, String comment) throws IntegrationModuleException;

    public String archivePrescription(String rid) throws IntegrationModuleException;
}
