package be.business.connector.gfddpp.tipsystem.offline.queue;

import be.business.connector.core.utils.EncryptionUtils;
import be.business.connector.core.utils.PropertyHandler;

public class EHealthMessageQueueFacade {
	private MessageQueue<EHealthMessage> queue;
	
	public EHealthMessageQueueFacade(PropertyHandler propertyHandler,EncryptionUtils encryptionUtils) {
		try {
			queue = new MessageQueue<EHealthMessage>(propertyHandler,encryptionUtils);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
 
	public MessageQueue<EHealthMessage> getQueue() {
		return queue;
	}
	
	public void registerData(byte[] msg, String dGuidSGuid, String mGuid, String pharmacyId) {
		queue.add(new EHealthMessage(MethodName.REGISTERDATA.toString(), msg,dGuidSGuid,mGuid,pharmacyId));
	}
	
	public void updateData(byte[] msg, String dGuidSGuid, String mGuid, String pharmacyId) {
		queue.add(new EHealthMessage(MethodName.UPDATEDATA.toString(), msg,dGuidSGuid,mGuid,pharmacyId));
	}
	
	public void deleteData(byte[] msg, String dGuidSGuid, String mGuid, String pharmacyId) {
		queue.add(new EHealthMessage(MethodName.REVOKEDATA.toString(), msg,dGuidSGuid,mGuid,pharmacyId));
	}
}
