package be.business.connector.mycarenet.services;

import org.apache.log4j.Logger;


import be.business.connector.core.exceptions.IntegrationModuleException;
import be.business.connector.core.services.GenericWebserviceCaller;
import be.business.connector.projects.common.utils.EndpointResolver;
import be.fgov.ehealth.insurability.protocol.v1.AliveCheckRequest;
import be.fgov.ehealth.insurability.protocol.v1.AliveCheckResponse;
import be.fgov.ehealth.insurability.protocol.v1.GetInsurabilityForPharmacistRequest;
import be.fgov.ehealth.insurability.protocol.v1.GetInsurabilityForPharmacistResponse;

public class InsurabilityConsultationServiceImpl implements InsurabilityConsultationService {

	/** The Constant LOG. */
	private final static Logger LOG = Logger.getLogger(InsurabilityConsultationServiceImpl.class);

	private static final String ENDPOINT_NAME = "endpoint.insurability";

	private static InsurabilityConsultationService insurabilityConsultationService;

	private InsurabilityConsultationServiceImpl() {
	}

	/**
	 * Gets the singleton instance of PcdhServiceImpl.
	 * 
	 * @return singleton instance of PcdhServiceImpl
	 */
	public static InsurabilityConsultationService getInstance() {
		if (insurabilityConsultationService == null) {
			insurabilityConsultationService = new InsurabilityConsultationServiceImpl();
		}
		return insurabilityConsultationService;
	}

	@Override
	public AliveCheckResponse aliveCheck(AliveCheckRequest aliveCheckRequest) throws IntegrationModuleException {
		return GenericWebserviceCaller.callGenericWebservice(aliveCheckRequest, AliveCheckResponse.class, EndpointResolver.getEndpointUrlString(ENDPOINT_NAME), getClass().getName(), true, true, true, true);
	}

	@Override
	public GetInsurabilityForPharmacistResponse getInsurabilityForPharmacist(GetInsurabilityForPharmacistRequest getInsurabilityForPharmacistRequest) throws IntegrationModuleException {
		return GenericWebserviceCaller.callGenericWebservice(getInsurabilityForPharmacistRequest, GetInsurabilityForPharmacistResponse.class, EndpointResolver.getEndpointUrlString(ENDPOINT_NAME), getClass().getName(), true, true, true, true);
	}

}
