package be.business.connector.recipe.patient.domain;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import be.recipe.services.core.ResponseType;

/**
 * The Class ListAddressedPrescriptionResult.
 */
@XmlRootElement(namespace = "http:/services.recipe.be/patient")
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ListPatientPrescriptionsResult")
public class ListPatientPrescriptionsResult extends ResponseType {

	/** The addressed notification. */
	@XmlElement(name = "prescriptions")
	private List<ListPatientPrescriptionItem> prescriptions = new ArrayList<ListPatientPrescriptionItem>();

	/**
	 * Instantiates a new list patient prescriptions result.
	 *
	 * @param prescriptions
	 *            the prescriptions
	 */
	public ListPatientPrescriptionsResult(List<ListPatientPrescriptionItem> prescriptions) {
		super();
		this.prescriptions = prescriptions;
	}

	/**
	 * Instantiates a new list patient prescriptions result.
	 */
	public ListPatientPrescriptionsResult() {
		super();
	}

	/**
	 * Gets the prescriptions.
	 *
	 * @return the prescriptions
	 */
	public List<ListPatientPrescriptionItem> getPrescriptions() {
		return prescriptions;
	}

	/**
	 * Sets the prescriptions.
	 *
	 * @param prescriptions
	 *            the new prescriptions
	 */
	public void setPrescriptions(List<ListPatientPrescriptionItem> prescriptions) {
		this.prescriptions = prescriptions;
	}

	/**
	 * Adds the.
	 *
	 * @param e
	 *            the e
	 * @return true, if successful
	 */
	public boolean add(ListPatientPrescriptionItem e) {
		return prescriptions.add(e);
	}

}
