package be.business.connector.recipe.patient.services;

import be.business.connector.core.exceptions.IntegrationModuleException;
import be.recipe.services.patient.CreateRelation;
import be.recipe.services.patient.CreateRelationResponse;
import be.recipe.services.patient.CreateReservation;
import be.recipe.services.patient.CreateReservationResponse;
import be.recipe.services.patient.GetPrescriptionForPatient;
import be.recipe.services.patient.GetPrescriptionForPatientResponse;
import be.recipe.services.patient.GetPrescriptionStatus;
import be.recipe.services.patient.GetPrescriptionStatusResponse;
import be.recipe.services.patient.GetVision;
import be.recipe.services.patient.GetVisionResponse;
import be.recipe.services.patient.ListOpenRids;
import be.recipe.services.patient.ListOpenRidsResponse;
import be.recipe.services.patient.ListPatientPrescription;
import be.recipe.services.patient.ListPatientPrescriptionResponse;
import be.recipe.services.patient.ListRelations;
import be.recipe.services.patient.ListRelationsResponse;
import be.recipe.services.patient.ListRidsHistory;
import be.recipe.services.patient.ListRidsHistoryResponse;
import be.recipe.services.patient.PutVision;
import be.recipe.services.patient.PutVisionResponse;
import be.recipe.services.patient.RevokePrescription;
import be.recipe.services.patient.RevokePrescriptionResponse;
import be.recipe.services.patient.RevokeRelation;
import be.recipe.services.patient.RevokeRelationResponse;
import be.recipe.services.patient.UpdateFeedbackFlag;
import be.recipe.services.patient.UpdateFeedbackFlagResponse;

/**
 * The Interface RecipePatientServiceV4.
 */
public interface RecipePatientServiceDevV4 {

	GetPrescriptionForPatientResponse getPrescriptionForPatient(GetPrescriptionForPatient getPrescriptionForPrescriberRequest)
			throws IntegrationModuleException;

	RevokePrescriptionResponse revokePrescription(RevokePrescription revokePrescriptionRequest) throws IntegrationModuleException;

	UpdateFeedbackFlagResponse updateFeedbackFlag(UpdateFeedbackFlag updateFeedbackFlagRequest) throws IntegrationModuleException;

	GetVisionResponse getVision(GetVision request)throws IntegrationModuleException;

	PutVisionResponse putVision(PutVision request)throws IntegrationModuleException;
	
	ListRelationsResponse listRelations(ListRelations request)throws IntegrationModuleException;

	CreateRelationResponse createRelation(CreateRelation request)throws IntegrationModuleException;
	
	RevokeRelationResponse revokeRelation(RevokeRelation request)throws IntegrationModuleException;

	CreateReservationResponse createReservation(CreateReservation request)throws IntegrationModuleException;

	GetPrescriptionStatusResponse getPrescriptionStatus(GetPrescriptionStatus request)throws IntegrationModuleException;

	ListRidsHistoryResponse listRidsHistory(ListRidsHistory request)throws IntegrationModuleException;
	
	ListOpenRidsResponse listOpenRids(ListOpenRids listOpenPrescriptionsRequest)
			throws IntegrationModuleException;

	ListPatientPrescriptionResponse listOpenPrescriptions(ListPatientPrescription request)throws IntegrationModuleException;

}