package be.business.connector.recipe.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.log4j.Logger;

import be.business.connector.core.exceptions.IntegrationModuleException;
import be.business.connector.core.utils.I18nHelper;

public class RidValidator {
	private static final String RID_PATTERN = "BE(P|K|N)(P|0|1|2|3|4|5|6|7|8|9)[(0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | A | B | C | D | E | F | G | H | J | K | L | M | N | P | Q | R | S | T | V | W | X | Y | Z)]{8}";
	private static final int RID_LENGTH = 12;
	private static final Pattern ridPattern = Pattern.compile(RID_PATTERN);

	private static final Logger LOG = Logger.getLogger(RidValidator.class);

	private RidValidator() {
	}

	@Deprecated
	private static void validateExecutorRidV4(final String rid) throws IntegrationModuleException {
		validateRid(rid);
	}

	@Deprecated
	private static void validateExecutorRid(final String rid) throws IntegrationModuleException {
		validateRid(rid);
	}

	@Deprecated
	private static void validatePrescriberRid(final String rid) throws IntegrationModuleException {
		validateRid(rid);
	}

	@Deprecated
	private static void validatePatientRid(final String rid) throws IntegrationModuleException {
		validateRid(rid);
	}

	public static void validateRid(final String rid) throws IntegrationModuleException {
		final Matcher ridMatcher = ridPattern.matcher(rid);
		if (!ridMatcher.find() || rid.length() != RID_LENGTH) {
			LOG.error("Invalid RID was provided.");
			throw new IntegrationModuleException(I18nHelper.getLabel("error.rid.validation", new Object[] { rid }));
		}
	}
}
